<?php // Copyright 2013-2014 Theo CMS http://theocms.com/. License GPLv3. Config v1.8.
if (!defined('THEO')) exit;

// DATABASE: Add database user, pass and name.
$dbuser = '';
$dbpass = '';
$dbname = '';
$pre = 'th_'; // Prefix (recommended): Backups contain only Theo related tables (vs all in $dbname).

// LANGUAGE
$L = array(
'cat'=>'Category',
'posted'=>'Posted',
'in'=>'in',
'on'=>'on',
'by'=>'by',
'of'=>'Of',
'as'=>'as',
'readmore'=>'Read More',
'page'=>'Page',
'search'=>'Search',
'archive'=>'Archive',
'tagged'=>'Tagged',
'comments'=>'Comments',
'comclosed'=>'Comments are closed for this post.',
'leavecom'=>'Leave a comment?',
'leavecomfirst'=>'Be the first to comment?',
'name'=>'Name',
'site'=>'Site',
'email'=>'Email',
'notpub'=>'(not published)',
'submit'=>'Submit',
'comreq'=>'A required field was missing.',
'comwrong'=>'Challenge answer incorrect.',
'comwait'=>'Comment awaiting moderation.',
'from'=>'From',
'not'=>'not',
'allowed'=>'allowed',
'comment'=>'Comment',
'notify'=>'Notify',
'tagitems'=>'Items tagged with',
'searchres'=>'Search results for',
'errsearch4'=>'Search must contain 4 or more letters.',
'noresult'=>'Nothing found.',
'404'=>'<h3>Not Found</h3>It probably moved, try the search feature.',
'nocatposts'=>'No posts <cat name> yet, check back soon!'
);

// LANGUAGE ADMIN
if (THEO === 'admin') {
$L += array(
'admin'=>'Admin',
'user'=>'User',
'pass'=>'Pass',
'login'=>'Login',
'held'=>'Held',
'logout'=>'Logout',
'cdraft'=>'*Draft',
'edit'=>'Edit',
'pages'=>'Pages',
'new'=>'New',
'post'=>'Post',
'subcat'=>'Subcategory',
'themes'=>'Themes',
'settings'=>'Settings',
'title'=>'Title',
'imgfile'=>'Image/File',
'intro'=>'Intro',
'linebr'=>'Break',
'head'=>'Heading',
'link'=>'Link',
'capt'=>'Caption',
'pre'=>'Pre',
'bold'=>'Bold',
'ital'=>'Italic',
'quot'=>'Quote',
'addin'=>'Add-In',
'save'=>'Save',
'tags'=>'Tags',
'desc'=>'Description',
'kwords'=>'Keywords',
'change'=>'Change',
'date'=>'Date',
'pub'=>'Publish',
'preview'=>'Preview',
'remove'=>'Remove',
'remwarn'=>'Removes <b>all post content</b>.',
'confirm'=>'Confirm',
'jsIntro'=>'OK = Regular Image\n\nCancel = Intro Image\n',
'jsImg'=>'OK = Style: Image\n\nCancel = Style: Thumbnail\n\n',
'jsImgAlt'=>'Alt Text\n\n',
'jsLink'=>'Link Text\n\n',
'url'=>'URL',
'avail'=>'Available',
'none'=>'None',
'unapp'=>'Unapproved',
'back'=>'Back',
'close'=>'Close',
'open'=>'Open',
'allow'=>'Allow',
'hide'=>'Hide',
'themecur'=>'Current Theme',
'no'=>'No',
'updateindex'=>'Site index does not match theme index, the <b><new></b> index is newer. Update the <b><old></b> index?',
'themeup'=>'Upload (file, zip or tar.gz)',
'send'=>'Send',
'set'=>'Set',
'themefiles'=>'Additional Theme Files',
'modcom'=>'Moderate Comments',
'loginu'=>'Login Requires User Field',
'pagi'=>'Posts Per Page',
'datestyle'=>'Date Style',
'baseurl'=>'Base href',
'tagline'=>'Tagline',
'comquestion'=>'Comment Question',
'comanswer'=>'Comment Answer',
'update'=>'Update',
'add'=>'Add',
'adding'=>'Adding',
'ugrp1'=>'Primary',
'errpassexist'=>'Unable to update password.',
'errpassmatch'=>'Passwords do not match.',
'errusrfield'=>'User field missing.',
'other'=>'Other',
'sitemap'=>'Refresh Sitemap',
'done'=>'Sitemap updated.',
'updaterobots'=>'* Add the following line to robots.txt:',
'backup'=>'Backup',
'dbbackup'=>'database backed up to',
'chkcur'=>'Check Latest Version',
'errchkcur'=>'Unable to retrieve. Check theocms.com for latest version info.'
);
}

mysql_connect('localhost', $dbuser, $dbpass);
mysql_select_db($dbname);

date_default_timezone_set('UTC');

// GET SETTINGS
$res = mysql_query("SELECT * FROM ".$pre."settings");
while ($r = mysql_fetch_assoc($res)) {
 if (strpos($r['xtra'], 'u_') === FALSE) {
  $S[$r['setting']] = array('value'=>$r['value'], 'meta1'=>$r['meta1'], 'meta2'=>$r['meta2'], 'xtra'=>$r['xtra']);
 } else {
  $U[$r['id']] = array('user'=>$r['setting'], 'pass'=>$r['value'], 'name'=>$r['meta1'], 'email'=>$r['meta2'], 'group'=>$r['xtra']);
 }
}

// OUTPUT MARKUP
function nl2p($text) {
 $text = '<p>'.$text.'</p>';
 return str_replace(
 array("\r\n\r\n", "3>\r\n", "4>\r\n", "<p><h", "3></p>", "4></p>", "<p><d", "\"></p>", "<p></d", "v></p>", "<p><p", "re></p>", "<p><sc", "t></p>", "<p><f", "m></p>", "<p><ul", "l></p>", "<p> "),
 array("</p>\n<p>", "3>\n<p>", "4>\n<p>", "<h", "3>", "4>", "<d", "\">", "</d", "v>", "<p", "re>", "<sc", "t>", "<f", "m>", "<ul", "l>", " "),
 $text);
}

// SANITIZE INPUT: Use 2nd parameter for visitor input.
function clean($input, $vis = '') {
 if (get_magic_quotes_gpc()) $input = stripslashes($input);
 if ($vis) $input = htmlspecialchars($input);
 return mysql_real_escape_string($input);
}

// PLUGIN STRINGS
$style = $optdisp = '';
?>