<?php // Copyright 2013-2014 Theo CMS http://theocms.com/. License GPLv3. Engine v1.8.
define('THEO', 'engine');
require 'config.php';
include 'plugins.php';

// URL, QUERY AND VARS
if (empty($_GET['url'])) $_GET['url'] = '';
$url = isset($_GET['url']) ? explode('/', clean($_GET['url'], 1)) : array('', '', '', '');
$postin = isset($_GET['p']) ? clean($_GET['p'], 1) : '0';
if (!$S['pagi']['value']) $S['pagi']['value'] = '30';
$res = array();
// Tag
if (isset($_GET['tag'])) {
 if (!$url[0]) {
  $mode = 'list';
  $tag = str_replace('-', ' ', clean($_GET['tag'], 1));
  $res['mdesc'] = $L['tagitems'].' '.$tag.' '.$L['on'].' '.$_SERVER['HTTP_HOST'];
  $title = $L['tagged'].': '.$tag;
  $heading = $L['tagitems'].' <i>'.$tag.'</i>';
  $query = mysql_query("SELECT a.title, a.titlesef, a.date, b.name, b.namesef, c.namesef AS primesef FROM ".$pre."posts a LEFT JOIN ".$pre."categories b ON b.id=a.category LEFT JOIN ".$pre."categories c ON c.id=b.subcat WHERE a.tags LIKE '%".$tag."%' AND a.pub=1 GROUP BY a.id DESC");
 }
// Archive
} elseif (isset($_GET['archive'])) {
 if (!$url[0]) {
  $mode = 'list';
  $res['mdesc'] = $L['archive'].' '.$L['of'].' '.$_SERVER['HTTP_HOST'];
  $title = $heading = $L['archive'];
  $query = mysql_query("SELECT a.title, a.titlesef, a.date, b.namesef, c.namesef AS primesef FROM ".$pre."posts a LEFT JOIN ".$pre."categories b ON b.id=a.category LEFT JOIN ".$pre."categories c ON c.id=b.subcat WHERE a.pub=1 GROUP BY a.id DESC");
 }
// Search
} elseif (isset($_POST['search'])) {
 $mode = 'list';
 $search = clean($_POST['search'], 1);
 $res['mdesc'] = $L['searchres'].' '.$search.' '.$L['on'].' '.$_SERVER['HTTP_HOST'];
 $title = $L['search'].': '.$search;
 if (strlen($search) < 4) {
  $heading = $L['errsearch4'];
 } else {
  $query = mysql_query("SELECT a.title, a.titlesef, a.date, b.name, b.namesef, c.namesef AS primesef FROM ".$pre."posts a LEFT JOIN ".$pre."categories b ON b.id=a.category LEFT JOIN ".$pre."categories c ON c.id=b.subcat WHERE (a.title LIKE '%".$search."%' OR a.text LIKE '%".$search."%') AND a.pub=1 GROUP BY a.id DESC");
  $heading = $L['searchres'].' <i>'.$search.'</i>';
 }
// Homepage or Category
} elseif (!end($url)) {
 if (empty($url[2])) {
  if ($url[0]) {
   if ($url[1]) {
    $cats = mysql_query("SELECT a.id, a.name FROM ".$pre."categories a LEFT JOIN ".$pre."categories b ON a.subcat=b.id WHERE a.namesef='$url[1]' AND b.namesef='$url[0]'");
   } else {
    $cats = mysql_query("SELECT a.name, b.id FROM ".$pre."categories a LEFT JOIN ".$pre."categories b ON b.id=a.id OR b.subcat=a.id WHERE a.namesef='$url[0]' AND a.subcat=0");
   }
   while ($cat = mysql_fetch_assoc($cats)) {
    $id[] = $cat['id'];
    $title = $cat['name'];
   }
   $res['mdesc'] = $L['posted'].' '.$L['in'].' '.$L['cat'].' '.$title.' '.$L['on'].' '.$_SERVER['HTTP_HOST'];
   if ($url[1]) $canonical = "\n".' <link rel="canonical" href="http://'.$_SERVER['HTTP_HOST'].$S['baseurl']['value'].$url[0].'/" />'."\n".' <meta name="robots" content="noindex, follow" />';
  }
  if (isset($title) || !$url[0]) {
   $pool = (isset($id) ? ' category IN ('.implode(',', $id).') AND' : '');
   $posttotal = mysql_num_rows(mysql_query("SELECT id FROM ".$pre."posts WHERE".($pool ? $pool : ' category!=0 AND')." pub=1"));
   $query = mysql_query("SELECT a.title, a.titlesef, a.text, a.date, a.showcom, a.editby, b.name, b.namesef, c.namesef AS primesef, COUNT(d.id) AS comnum FROM ".$pre."posts a INNER JOIN ".$pre."categories b ON b.id=a.category LEFT JOIN ".$pre."categories c ON c.id=b.subcat LEFT JOIN ".$pre."comments d ON d.post=a.id AND d.allow=1 WHERE".$pool." a.pub=1 GROUP BY a.id DESC LIMIT $postin, ".$S['pagi']['value']."");
   if ($postin < $posttotal) $mode = 'cat';
  }
 }
// Post
} else {
 if (empty($url[3])) {
  $preview = (isset($_GET['preview_key']) && $_GET['preview_key'] === substr($_COOKIE['PHPSESSID'], 17) ? '' : 'AND a.pub=1');
  $select = 'SELECT a.id, a.title, a.text, a.date, a.tags, a.showcom, a.closecom, a.editby, a.mdesc, a.mkwords FROM '.$pre.'posts a';
  if (isset($url[2])) {
   $res = mysql_fetch_assoc(mysql_query("$select LEFT JOIN categories b ON a.category=b.id LEFT JOIN categories c ON b.subcat=c.id WHERE a.titlesef='".end($url)."' $preview AND b.namesef='$url[1]' AND c.namesef='$url[0]'"));
  } elseif (isset($url[1])) {
   $res = mysql_fetch_assoc(mysql_query("$select LEFT JOIN categories b ON a.category=b.id WHERE titlesef='".end($url)."' $preview AND b.namesef='$url[0]'"));
  } else {
   $res = mysql_fetch_assoc(mysql_query("$select WHERE a.titlesef='".end($url)."' $preview AND a.category=0"));
  }
  if ($res['id']) {
   $mode = 'post';
   $query = mysql_query("SELECT name, email, site, date, comment FROM ".$pre."comments WHERE post=$res[id] AND allow=1 ORDER BY id"); // Comments
   $title = $res['title'];
  }
 }
}

if (empty($mode)) {
 header("HTTP/1.0 404 Not Found");
 $mode = '404';
}

// PAGE TITLE
function title() {
 global $S, $res, $canonical, $title, $mode, $style;
 $desc = ($S['site']['meta1'] ? "\n".' <meta name="description" content="'.$S['site']['meta1'].'" />' : '');
 if (!empty($res['mdesc'])) $desc = "\n".' <meta name="description" content="'.$res['mdesc'].'" />';
 $kwrd = ($S['site']['meta2'] ? "\n".' <meta name="keywords" content="'.$S['site']['meta2'].'" />' : '');
 if (!empty($res['mkwords'])) $kwrd = "\n".' <meta name="keywords" content="'.$res['mkwords'].'" />';
 $canonical = isset($canonical) ? $canonical : '';
 echo '<title>'.($title ? $title.' - '.$S['site']['value'] : $S['site']['value']).'</title>'.$desc.$kwrd.'
 <meta name="generator" content="Theo CMS" />'.$canonical.'
 <base href="'.$S['baseurl']['value'].'" />'."\n";
 if ($mode === 'post' && $res['showcom'] && !$res['closecom']) $style .= ' .firstname {display:none;}';
 if ($style) echo ' <style type="text/css">'.$style.' </style>'."\n";
}

// HOME LINK
function home() {
 global $S;
 echo '<a href="" class="homeink">'.$S['site']['value'].'</a>'."\n";
 if ($S['site']['xtra']) echo '<span class="tagline">'.$S['site']['xtra'].'</span>'."\n";
}

// MENU
function menu() {
 global $pre;
 echo '<ul>'."\n";
 $catq = mysql_query("SELECT a.namesef, a.name, b.subcat FROM ".$pre."categories a LEFT JOIN ".$pre."categories b ON b.subcat=a.id WHERE a.subcat=0 GROUP BY a.id");
 while ($cat = mysql_fetch_assoc($catq)) {
  echo ' <li><a href="'.$cat['namesef'].'/">'.$cat['name'].'</a>';
  if ($cat['subcat']) {
   echo "\n".'  <ul>'."\n";
   $subq = mysql_query("SELECT namesef, name FROM ".$pre."categories WHERE subcat=$cat[subcat]");
   while ($sub = mysql_fetch_assoc($subq)) {
    echo '   <li><a href="'.$cat['namesef'].'/'.$sub['namesef'].'/">'.$sub['name'].'</a></li>'."\n";
   }
   echo '  </ul>'."\n".' </li>'."\n";
  } else {
   echo '</li>'."\n";
  }
 }
 echo '</ul>'."\n";
}

// SEARCH FORM: ('ThemeName/button-name.png')
function search($button = '') {
 echo '<form method="post" action="index.php" class="search">
 <input type="text" name="search" maxlength="14" value="search" onclick="value=\'\'" class="searchbox" />';
 if ($button) echo '<input type="image" src="th-themes/'.$button.'" alt="Search" class="searchbtn" />';
 echo "\n".'</form>'."\n";
}

// PAGEINATION
if (isset($posttotal) && $posttotal > $S['pagi']['value']) {
 $pagetotal = ceil($posttotal / $S['pagi']['value']);
 $page[1] = 0;
 $p = '';
 for ($i = 0; $i < $pagetotal; $i++) {
  $p = $p + $S['pagi']['value'];
  $page[($i + 2)] = $p;
 }
 $pagenum = array_search($postin, $page);
 $link = '<a href="'.(empty($_GET['url']) ? '' : $_GET['url']).'&amp;p=';
 $left = ($pagenum == $pagetotal ? '' : $link.($postin + $S['pagi']['value']).'" class="pagileft"></a>');
 $right = ($pagenum === 1 ? '' : $link.($postin - $S['pagi']['value']).'" class="pagiright"></a>');
 $pagelinks = '<div id="pagi">'.$left.'<span>'.$pagenum.' '.$L['of'].' '.$pagetotal.'</span>'.$right.'</div>'."\n";
}

// MAIN
function main() {
 global $mode, $posttotal, $heading, $res, $query, $L, $S, $U, $title, $pagelinks;
 switch ($mode) {

  // POST
  case 'post':
  if (substr($res['text'], 0, 3) === '<im') $res['text'] = substr_replace($res['text'], '', strpos($res['text'], '</a>'), 4);
  $intro = strpos($res['text'], '[INTRO]');
  if ($intro !== FALSE) $res['text'] = substr_replace($res['text'], '', $intro, 7);
  $addin = strpos($res['text'], '[ADD]');
  if ($addin !== FALSE) {
   $text = explode('[ADD]', str_replace('[/ADD]', '[ADD]', $res['text']));
   foreach ($text as $key => $call) {
    if (($key & 1)) {
     $call = substr_replace($call, '-', strpos($call, '('), 0).'-';
     $call = explode('-(', str_replace(')-', '-(', $call));
     $text[$key] = (substr($call[1], 0, 1) === '"' ? call_user_func($call[0], trim($call[1], '"')) : call_user_func_array($call[0], explode(',', $call[1])));
    }
   }
   $res['text'] = implode($text);
  }
  echo '<div class="post">
  <h1>'.$res['title'].'</h1>
  '.nl2p($res['text'])."\n";
  if ($S['postby']['value'] && isset($U[$res['editby']])) echo '<div class="postedby">'.$L['posted'].' '.$L['by'].' '.$U[$res['editby']]['name'].'.</div>'."\n";
  if ($res['tags']) {
   $tags = explode(', ', $res['tags']);
   $taglinks = '';
   foreach ($tags as $tag) $taglinks .= ' <a href="?tag='.str_replace(' ', '-', $tag).'">'.$tag.'</a>,';
   echo '<div class="tagged">
   <h4>'.$L['tagged'].'</h4>
   '.rtrim($taglinks, ',').'
   </div><!--/tagged-->'."\n";
  }
  // Display comments.
  if ($res['showcom']) {
   while ($tmp = mysql_fetch_assoc($query)) $coms[] = $tmp;
   if (isset($coms)) {
    $email = '';
    foreach ($U as $u) $email .= $u['email'];
    echo "\n".'<div class="comments">
    <h4 id="comments">'.$L['comments'].'</h4>'."\n";
    foreach ($coms as $com) {
     echo '<div class="comment">
     <div class="comment-'.(!empty($com['email']) && strpos($email, $com['email']) !== FALSE ? 'user' : 'name').'">'.
     (empty($com['site']) ? $com['name'] : '<a href="http://'.$com['site'].'" target="_blank" rel="nofollow">'.$com['name'].'</a>').'</div>
     <div class="comment-date">'.date($S['datestyle']['value'], strtotime($com['date'])).'</div>
     <div class="comment-txt">'."\n".nl2p($com['comment']).'
     </div>'."\n".'</div>'."\n";
    }
    echo '</div><!--/comments-->'."\n";
    $msg = $L['leavecom'];
   } else {
    $msg = $L['leavecomfirst'];
   }
   // Comment form.
   if ($res['closecom']) {
    echo '<div class="commentsclosed">'.$L['comclosed'].'</div>';
   } else {
    if (empty($_POST)) $_POST['commenter'] = $_POST['site'] = $_POST['email'] = $_POST['comment'] = '';
    echo '<div class="commentForm">
    <h4 id="comment">'.$msg.'</h4>
    <form method="post" action="'.$_SERVER['REQUEST_URI'].'">
    <input type="text" name="name" id="name" class="firstname" />
    <label>'.$L['name'].' * <input type="text" name="commenter" maxlength="25" value="'.$_POST['commenter'].'" /></label>
    <label>'.$L['site'].' <input type="text" name="site" maxlength="40" value="'.$_POST['site'].'" /></label>
    <label>'.$L['email'].' <span>'.$L['notpub'].'</span> <input type="text" name="email" maxlength="30" value="'.$_POST['email'].'" /></label>
    <textarea name="comment" rows="8" cols="50">'.$_POST['comment'].'</textarea>';
    if (isset($S['comask']['value'])) echo '<div class="comment-question">'.htmlspecialchars_decode($S['comask']['value']).' <input type="text" name="comanswer" maxlength="70" /></div>';
    echo '<input type="submit" id="submit" name="submit" value="'.$L['submit'].'" class="submit" />
    </form><div class="clear"></div>'."\n";
    // Filter submitted comment.
    if (isset($_POST['submit']) && !$_POST['name']) {
     if (!$_POST['commenter'] || !$_POST['comment'] || isset($S['comask']['value']) && !$_POST['comanswer']) {
      echo '<script type="text/javascript">location.hash="comment";</script>
      <div class="message">'.$L['comreq'].'</div>'."\n";
     } elseif (isset($S['comask']['value']) && $_POST['comanswer'] !== $S['comask']['meta1']) {
      echo '<script type="text/javascript">location.hash="comment";</script>
      <div class="message">'.$L['comwrong'].'</div>'."\n";
     } else {
      $xml = file_get_contents('http://stopforumspam.com/api?ip='.$_SERVER['REMOTE_ADDR'].'&email='.$_POST['email'].'');
      if (strpos($xml, '>yes<')) {
       exit;
      } else {
       // All clear, save comment and notify.
       if ($_POST['site']) $_POST['site'] = str_replace(array('https://', 'http://', 'www.'), '', clean($_POST['site'], 1));
       mysql_query("INSERT INTO ".$GLOBALS['pre']."comments VALUES ('', $res[id], '".$S['comallow']['value']."', '".clean($_POST['commenter'], 1)."', '".clean($_POST['email'], 1)."', '$_POST[site]', NOW(), '".clean($_POST['comment'], 1)."')");
       if ($S['comallow']['value']) {
        header('Location: #comment');
       } else {
        echo '<script type="text/javascript">location.hash="comment";submit.disabled=true;setTimeout(function()submit.disabled=false,10000);</script>
        <div class="message">'.$L['comwait'].'</div>'."\n";
        header('Refresh: 3;');
       }
       if ($S['notify']) {
        mail($S['notify']['value'], $L['comment'].' '.$L['from'].' '.strip_tags($_POST['commenter']).' ('.($S['comallow']['value'] ? '' : $L['not'].' ').$L['allowed'].')',
        '- '.$L['posted'].' '.$L['on'].':'."\n".$res['title']."\n\n".'- '.$L['comment'].':'."\n".strip_tags($_POST['comment']),
        $L['from'].': '.$L['notify'].' '.$L['notify'].'@'.$_SERVER['HTTP_HOST']);
       }
      }
     }
    }
    echo '</div><!--/commentForm-->'."\n";
   }
  }
  echo '</div><!--/post-->'."\n";
  break;

  // TAG, SEARCH OR ARCHIVE
  case 'list':
  echo '<div class="list">
  <h3>'.$heading.'</h3>'."\n";
  if ($heading === $L['archive']) echo '<div class="archive">'."\n";
  if ($query) {
   if (mysql_num_rows($query) === 0) {
    echo $L['noresult']."\n";
   } else {
    $var = '';
    while ($r = mysql_fetch_assoc($query)) {
     $linkst = (isset($r['namesef']) ? '<a href="'.($r['primesef'] ? $r['primesef'].'/'.$r['namesef'] : $r['namesef']).'/' : '<a href="');
     if ($heading === $L['archive']) {
      $date = date('F Y', strtotime($r['date']));
      if ($var <> $date) echo '<div class="archivedate">'.$date.'</div><br />'."\n";
      $var = $date;
     }
     echo $linkst.$r['titlesef'].'">'.$r['title'].'</a><br />'."\n";
     if ($heading !== $L['archive']) echo '<div class="listinfo">'.$L['posted'].' '.($r['namesef'] ? $L['in'].' '.$linkst.'">'.$r['name'].'</a>' : $L['as'].' '.$L['page']).' '.$L['on'].' '.date($S['datestyle']['value'], strtotime($r['date'])).'.</div>'."\n";
    }
   }
  }
  if ($heading === $L['archive']) echo '</div>'."\n";
  echo '</div><!--/list-->'."\n";
  break;

  // 404
  case '404':
  echo $L['404'];
  break;

  // HOMEPAGE OR CATEGORY
  default:
  if ($posttotal) {
   while ($r = mysql_fetch_assoc($query)) {
    $linkst = '<a href="'.($r['primesef'] ? $r['primesef'].'/'.$r['namesef'] : $r['namesef']).'/';
    echo '<div class="posts">
    <h2>'.$linkst.$r['titlesef'].'">'.$r['title'].'</a></h2>'."\n";
    $text = explode('[INTRO]', $r['text']); // Substring may not get first char, explode instead.
    if (substr($text[0], 0, 3) === '<im') $text[0] = $linkst.$r['titlesef'].'">'.$text[0];
    $addin = strpos($text[0], '[ADD]');
    if ($addin !== FALSE) {
     $add = explode('[ADD]', str_replace('[/ADD]', '[ADD]', $text[0]));
     foreach ($add as $key => $call) {
      if (($key & 1)) {
       $call = substr_replace($call, '-', strpos($call, '('), 0).'-';
       $call = explode('-(', str_replace(')-', '-(', $call));
       $add[$key] = (substr($call[1], 0, 1) === '"' ? call_user_func($call[0], trim($call[1], '"')) : call_user_func_array($call[0], explode(',', $call[1])));
      }
     }
     $text[0] = implode($add);
    }
    echo nl2p($text[0]).'
    <div class="postsinfo">'.$L['posted'].' '.$L['in'].' '.$linkst.'">'.$r['name'].'</a> '.$L['on'].' '.date($S['datestyle']['value'], strtotime($r['date']))
    .($S['postby']['value'] && isset($U[$r['editby']]) ? ' '.$L['by'].' '.$U[$r['editby']]['name'].'.' : '.');
    if ($r['showcom'] && $r['comnum']) echo ' '.$linkst.$r['titlesef'].'#comments">'.$r['comnum'].' '.$L['comments'].'</a>.';
    echo ' '.$linkst.$r['titlesef'].'">'.$L['readmore'].'</a>
    </div>'."\n".'</div><!--/posts-->'."\n";
   }
   echo $pagelinks;
  } else {
   echo str_replace('<cat name>', ($title ? $L['in'].' '.$title : ''), $L['nocatposts']);
  }
  break;
 }
}

// RECENT POSTS: (5) Show 5 posts.
function recent_posts($limit = 0) {
 global $pre;
 $row = mysql_query("SELECT a.title, a.titlesef, b.namesef, c.namesef AS parent FROM ".$pre."posts a, ".$pre."categories b LEFT JOIN ".$pre."categories c ON c.id=b.subcat WHERE a.pub=1 AND b.id=a.category GROUP BY a.id DESC LIMIT $limit");
 while ($res = mysql_fetch_assoc($row)) echo '<a href="'.($res['parent'] ? $res['parent'].'/'.$res['namesef'] : $res['namesef']).'/'.$res['titlesef'].'">'.$res['title'].'</a><br />'."\n";
}

// TAGS: (20, 14) Max and min font sizes for cloud, empty for list.
function tags($fmax = '', $fmin = '') {
 global $pre;
 $bulk = '';
 $row = mysql_query("SELECT tags FROM ".$pre."posts WHERE pub=1 AND tags !=''");
 while ($res = mysql_fetch_assoc($row)) $bulk .= ', '.$res['tags'];
 $tags = array_count_values(explode(', ', ltrim($bulk, ', ')));
 if ($fmax) {
  $tagmax = max($tags);
  $tagmin = min($tags);
  if ($tagmax === $tagmin) $tagmax = 0;
  $step = (($fmax - $fmin) / ($tagmax - $tagmin));
  foreach ($tags as $tag => $sum) {
   $fsize = round($fmin + (($sum - $tagmin) * $step));
   echo '<a href="&tag='.str_replace(' ', '-', $tag).'" title="'.$sum.' posts tagged '.$tag.'" style="font-size:'.$fsize.'px;">'.$tag.'</a> '."\n";
  }
 } else {
  foreach ($tags as $tag => $sum) echo '<a href="&tag='.str_replace(' ', '-', $tag).'" title="'.$sum.' posts tagged '.$tag.'">'.$tag.'</a><br />'."\n";
 }
}

// RECENT COMMENTS: (5, 200) Show 5 comments snipped at 200 characters.
function recent_comments($limit = 0, $chars = 0) {
 global $pre;
 $row = mysql_query("SELECT a.name, a.comment, b.titlesef, c.namesef, d.namesef AS parent FROM ".$pre."comments a, ".$pre."posts b, ".$pre."categories c LEFT JOIN ".$pre."categories d ON d.id=c.subcat WHERE a.allow=1 AND b.id=a.post AND b.pub=1 AND c.id=b.category GROUP BY a.id DESC LIMIT $limit");
 while ($res = mysql_fetch_assoc($row)) {
  $comment = substr($res['comment'], 0, $chars);
  echo '<a href="'.($res['parent'] ? $res['parent'].'/'.$res['namesef'] : $res['namesef']).'/'.$res['titlesef'].'#comments"><span>'.$res['name'].':</span>
  '.$comment.'...</a>'."\n";
 }
}

// PAGES
function pages() {
 global $pre;
 $row = mysql_query("SELECT title, titlesef FROM ".$pre."posts WHERE pub=1 AND category=0");
 while ($res = mysql_fetch_assoc($row)) echo '<a href="'.$res['titlesef'].'">'.$res['title'].'</a>'."\n";
}
?>